// progress.cpp : Defines the exported functions for the DLL application.
//

#include "stdafx.h"
#include "../mmf_queue/mmf_queue.h"
#include <conio.h>

extern "C"
{
	BOOL __declspec(dllexport) StartProgress();
	BOOL __declspec(dllexport) StopProgress();
}

// handle to unnamed manual reset event to signal StartProgress thread to stop
HANDLE hStopEvent=NULL;

// handle for Progress thread
HANDLE hThread;

// printing procedure
DWORD WINAPI progress(LPVOID lpParam){
	// indicator if printed any stars
	BOOL bPrintedStars=FALSE;

	// print '*' every second forever
	do {
		// check if should exit thread
		DWORD dwRes=WaitForSingleObject(hStopEvent,500);
		
		//exit if signaled or error
		if(dwRes!=WAIT_TIMEOUT) break;

		// no need of critical section
		Sleep(1000);
		_tprintf(_T("*"));

		bPrintedStars=TRUE;
	} while(1);

	// if printed stars, print newline
	if (bPrintedStars) _tprintf(_T("\n"));

	return 0;
}

BOOL StartProgress(){
	// create manual reset event in unsignaled state
	hStopEvent=::CreateEvent(NULL,TRUE,FALSE,NULL);
	assert(hStopEvent);

	// create thread for progress
	hThread=CreateThread(NULL,0,progress,NULL,0,NULL);
	assert(hThread);
	
	return TRUE;
}

BOOL StopProgress(){
	// set stop event for progress thread to exit
	BOOL bRes=SetEvent(hStopEvent);
	assert(bRes);

	// wait until progress thread is exited signaled
	DWORD dwRes=WaitForSingleObject(hThread,ALMOST_INFINITE);
	assert(dwRes==WAIT_OBJECT_0);

	// clean up
	CloseHandle(hStopEvent);
	CloseHandle(hThread);

	return TRUE;
}

