// writer.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "../mmf_queue/mmf_queue.h"

typedef BOOL (*pfnCreateQueue)(SHARED_QUEUE*);
typedef BOOL (*pfnDeleteQueue)(SHARED_QUEUE*);
typedef BOOL (*pfnPushElement)(SHARED_QUEUE*,DWORD);
typedef BOOL (*pfnPopElement)(SHARED_QUEUE*,DWORD*);

typedef struct
{
	pfnCreateQueue CreateQueue;
	pfnDeleteQueue DeleteQueue;
	pfnPushElement PushElement;
	pfnPopElement PopElement;
	HMODULE m_hDLL;
} QUEUE_LIB;

BOOL LoadQueueLibrary(QUEUE_LIB* queue_lib,LPCTSTR dllName)
{
	queue_lib->m_hDLL=LoadLibrary(dllName);
	assert(queue_lib->m_hDLL);
	queue_lib->CreateQueue=(pfnCreateQueue)GetProcAddress(queue_lib->m_hDLL,"pfnCreateQueue");
	queue_lib->DeleteQueue=(pfnDeleteQueue)GetProcAddress(queue_lib->m_hDLL,"pfnDeleteQueue");
	queue_lib->PushElement=(pfnPushElement)GetProcAddress(queue_lib->m_hDLL,"pfnPushElement");
	queue_lib->PopElement=(pfnPopElement)GetProcAddress(queue_lib->m_hDLL,"pfnPopElement");
	assert(queue_lib->CreateQueue && queue_lib->DeleteQueue && queue_lib->PushElement && queue_lib->PopElement);
	return TRUE;
}

//declarations for compile-time DLL binding
extern "C" {
	BOOL __declspec(dllimport) StartProgress();
	BOOL __declspec(dllimport) StopProgress();
}

int _tmain(int argc, _TCHAR* argv[]){
	// load input queue library
	assert(argc==2);
	QUEUE_LIB queue_lib;
	LoadQueueLibrary(&queue_lib,argv[1]);

	// create shared queue
	SHARED_QUEUE queue;
	queue_lib.CreateQueue(&queue);

	do {
		// read value from user
		DWORD dwElem;
		_tscanf(_T("%d"),&dwElem);

		StartProgress();	//start showing "star progress"

		// push data to queue
		queue_lib.PushElement(&queue,dwElem);

		StopProgress();		//end "star progress"

		// if got 0, exit
		if(!dwElem) break;

	} while(1);

	// delete queue
	queue_lib.DeleteQueue(&queue);
	FreeLibrary(queue_lib.m_hDLL);
	return 0;
}