// server.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <assert.h>
#include <math.h>
#define NUM_FILES 9.0
#define MAX_SIZE 256

BOOL ReadPhrase(LPCTSTR base_folder,char *pBuffer,DWORD maxSize){
	ZeroMemory(pBuffer,maxSize);
	DWORD nNum;
	do {
		nNum=(DWORD)floor((rand()*NUM_FILES)/RAND_MAX);
	} while (nNum==(DWORD)NUM_FILES);
	TCHAR file_name[MAX_PATH];
	_stprintf(file_name,_T("%s%d.txt"),base_folder,nNum);
	FILE* hFile=_tfopen(file_name,_T("rt"));
	assert(hFile);
	char* pRead=fgets(pBuffer,maxSize,hFile);
	assert(pRead);
	fclose(hFile);
	return true;
}

// server code
int _tmain(int argc, _TCHAR* argv[])
{
	// check command line input
	assert(argc==2);

	//initialize windows sockets
	WSADATA wsaData;
	int iResult = WSAStartup(MAKEWORD(2,2), &wsaData);
	assert(iResult==NO_ERROR);

	//create listen socket
	SOCKET hListenSocket= socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	assert(hListenSocket!=INVALID_SOCKET);

	//prepare address structure to bind listen socket
	sockaddr_in service;
	service.sin_family = AF_INET;
	service.sin_addr.s_addr = inet_addr("127.0.0.1");
	service.sin_port = htons(27015);

	//bind listen socket
	int iRes=bind( hListenSocket,(SOCKADDR*) &service,sizeof(service));
	assert(iRes!= SOCKET_ERROR);

	//start listening
	iRes=listen(hListenSocket,1);
	assert(iRes!=SOCKET_ERROR);

	do {
		//prepare structure for client(source) address
		sockaddr client_addr;
		int nLen=sizeof(client_addr);
		
		// create buffer to pass the client
		char buf[MAX_SIZE];
		BOOL bRes=ReadPhrase(argv[1],buf,MAX_SIZE);
		assert(bRes);

		//start waiting till client connects
		SOCKET hClientSocket=accept(hListenSocket,&client_addr,&nLen);
		assert(hClientSocket!=INVALID_SOCKET);

		// write buffer to client
		int nBytesToSend=sizeof(buf);
		int iPos=0;

		//loop while there's a data to send
		while(nBytesToSend)
		{
			//send next chunk
			int nSent=send(hClientSocket,buf+iPos,nBytesToSend,0);
			assert(nSent!=SOCKET_ERROR);
            
			//update counters and next bute position
			nBytesToSend-=nSent;
			iPos+=nSent;
		}
		
		// close socket
		closesocket(hClientSocket);

	} while (1);

	//close listen socket
	closesocket(hListenSocket);

	//release windows socket resources
	WSACleanup();

	return 0;
}